/* $Id: ball.hpp,v 1.3 2005/02/04 14:41:51 pohlt Exp $ */

#ifndef _BALL_HPP_
#define _BALL_HPP_

/**********************************************************/

#include "global.hpp"
#include "constants.hpp"
#include "collidableobject.hpp"
#include "audio.hpp"
#include "vector.hpp"

/**********************************************************/

class Ball : public CollidableObject {
	public:
		Ball();
		~Ball();
		bool initialize( const Vector& pos, const Vector& vel,
		                 const Sint32 initialScoringDelay );
		virtual Sint32 getID() const { return BALL; }
		virtual void update();
		virtual int applyDamage( const Particles::ParticleData& p );

		virtual void serialize( Uint8*& bufferPointer ) const;
		virtual void deserialize( Uint8*& bufferPointer );
		virtual Uint32 getSerializeBufferSize() const;

	protected:
		static Mix_Chunk* m_explodeSample, * m_bounceSample, * m_damageSample;
		Sint32 m_scoringDelay, m_initialScoringDelay;
};

/**********************************************************/

#endif /* _BALL_HPP_ */
