/* $Id: grenade.hpp,v 1.7 2004/10/12 07:42:35 uwe Exp $ */

#ifndef _GRENADE_HPP_
#define _GRENADE_HPP_

/**********************************************************/

#include "global.hpp"
#include "constants.hpp"
#include "collidableobject.hpp"
#include "audio.hpp"
#include "vector.hpp"

/**********************************************************/

class Grenade : public CollidableObject {
	friend class WeaponGrenade;
	public:
		Grenade();
		bool initialize( const Vector& pos, const Vector& vel,
		                 const Uint8 owner, const Sint32 ttl,
		                 const Sint32 nShrapnels, const Sint32 damage );
		virtual Sint32 getID() const { return GRENADE; }
		virtual void update();
		virtual int applyDamage( const Particles::ParticleData& p );

		virtual void serialize( Uint8*& bufferPointer ) const;
		virtual void deserialize( Uint8*& bufferPointer );
		virtual Uint32 getSerializeBufferSize() const;

	protected:
		Uint8  m_owner;
		Sint32 m_ttl;
		Sint32 m_nShrapnels;
		Sint32 m_damage;
		static Mix_Chunk *m_explodeSample,
		                 *m_bounceSample,
		                 *m_damageSample;
};

/**********************************************************/

#endif /* _GRENADE_HPP_ */
