/* $Id: hook.hpp,v 1.4 2004/12/13 09:41:59 pohlt Exp $ */

#ifndef _HOOK_HPP_
#define _HOOK_HPP_

/**********************************************************/

#include "global.hpp"
#include "constants.hpp"
#include "collidableobject.hpp"
#include "audio.hpp"

/**********************************************************/

class Avatar;

/**********************************************************/

class Hook : public CollidableObject {
	friend class WeaponHook;
	public:
		Hook();
		bool initialize( const Vector& pos, const Vector& vel );
		virtual Sint32 getID() const { return HOOK; }
		virtual void update();
		virtual int applyDamage( const Particles::ParticleData& p );
		bool isStickingInEarth() const { return m_stickingInEarth; }

		virtual void serialize( Uint8*& bufferPointer ) const;
		virtual void deserialize( Uint8*& bufferPointer );
		virtual Uint32 getSerializeBufferSize() const;

	protected:
		static Mix_Chunk* m_attachSample, * m_damageSample;
		bool m_stickingInEarth;
		Sint32 m_stickingAtX, m_stickingAtY;
};

/**********************************************************/

#endif /* _HOOK_HPP_ */
