/* $Id: weaponhomingmissile.hpp,v 1.1 2004/08/16 07:03:01 uwe Exp $ */

#ifndef _WEAPONHOMINGMISSILE_HPP_
#define _WEAPONHOMINGMISSILE_HPP_

/**********************************************************/

#include "weapon.hpp"
#include "homingmissile.hpp"
#include "audio.hpp"

/**********************************************************/

class WeaponHomingMissile : public Weapon
{
	public:
	
		WeaponHomingMissile() {
			rechargeNow();
			// load sample for fire action
			m_shotSample = Audio::getInstance()
			    ->loadSound( "sound/weapons/missile/launch.wav" );
			// load sample for explosion
			HomingMissile::m_explodeSample = Audio::getInstance()
			    ->loadSound( "sound/effects/explosion1.wav" );
			// load sample for this cool "pling, pling" :)
			HomingMissile::m_damageSample = Audio::getInstance()
			    ->loadSound( "sound/effects/ricochet.wav" );
		}

		virtual bool reallyShoot( World* world, Avatar* avatar ) const;
		
		virtual Uint32 getMaximumAmmo() const {
			return 1;
		}
		virtual Uint32 getReloadTime() const {
			return 15;
		}
		virtual Uint32 getChargeTime() const {
			return 100;
		}
};

/**********************************************************/

#endif // _WEAPONHOMINGMISSILE_HPP_
