/* $Id: weaponhook.cpp,v 1.6 2005/04/08 13:16:03 pohlt Exp $ */

#include "weaponhook.hpp"
#include "world.hpp"
#include "avatar.hpp"
#include "rope.hpp"
#include "scorekeeper.hpp"

bool WeaponHook::reallyShoot( World* world, Avatar* avatar ) const {
	// place hook
	Hook* const hook = dynamic_cast<Hook*>( world->newObject( HOOK ));

	if( hook->initialize(
	       avatar->placeBesideCollRect( hook->getCollRectX() + hook->getCollRectWidth() - 1,
	                                    -hook->getCollRectX(),
	                                    hook->getCollRectY() + hook->getCollRectHeight() - 1,
	                                    -hook->getCollRectY() ),
	       avatar->getRandomizedAimingVector( 3 )*(28.0 - 5.0 * globalRnd.getNormedReal()) +
	       avatar->getSpeed() ) == false ) return false;

	// create rope
	Rope* const rope = dynamic_cast<Rope*>( world->newObject( ROPE ));
	// attach rope to shooting avatar and hook
	rope->initialize( dynamic_cast<AttachableObject*>( avatar ),
	                  dynamic_cast<AttachableObject*>( hook ),
	                  avatar->getPlayer()->getPlayerOrTeamID(),
	                  200, avatar->getSkinColor() );

	return true;
}
