/* $Id: weaponhookrel.cpp,v 1.5 2005/04/08 13:16:03 pohlt Exp $ */

#include "weaponhookrel.hpp"
#include "world.hpp"
#include "avatar.hpp"
#include "rope.hpp"

bool WeaponHookRel::reallyShoot( World* world, Avatar* avatar ) const {
	// look for rope to release
	// \todo: make a better choice for the rope
	int a;
	AttachableObject* attachedObject = NULL;

	for( a = 0; a < avatar->getNAttachedObjects(); a++ ) {
		attachedObject = avatar->getAttachedObject( a );
		if( attachedObject->getID() == ROPE &&
		    (dynamic_cast<Rope*>(attachedObject))->getOwner() ==
		    avatar->getPlayer()->getPlayerOrTeamID() ) break;
	}

	if( a == avatar->getNAttachedObjects() ) return false;

	// place hook
	Hook* const hook = dynamic_cast<Hook*>( world->newObject( HOOK ));

	if( hook->initialize(
	       avatar->placeBesideCollRect( hook->getCollRectX() + hook->getCollRectWidth() - 1,
	                                    -hook->getCollRectX(),
	                                    hook->getCollRectY() + hook->getCollRectHeight() - 1,
	                                    -hook->getCollRectY() ),
	       avatar->getRandomizedAimingVector( 5 )*(28.0 - 5.0 * globalRnd.getNormedReal()) +
	       avatar->getSpeed() ) == false ) return false;

	// deattach rope from shooting avatar
	attachedObject->detachFrom( avatar );
	// attach to new hook
	attachedObject->attachTo( hook );
	

	return true;
}
