/* $Id: weaponmine.cpp,v 1.2 2005/04/08 13:16:03 pohlt Exp $ */

#include "weaponmine.hpp"
#include "world.hpp"
#include "avatar.hpp"

bool WeaponMine::reallyShoot( World* world, Avatar* avatar ) const {
	// place mine
	const real power = 1 + 0.25 * globalRnd.getNormedReal();
	const int deadTime = (globalRnd.getUint32Between( 0, 10 ) == 0 && false ? -1 // dud
	                      : static_cast<int>( globalRnd.getUint32Between( 75, 100 )));
	Mine* const mine = dynamic_cast<Mine*>( world->newObject( MINE ));
	return mine->initialize(
	       avatar->placeBesideCollRect( mine->getCollRectX() + mine->getCollRectWidth() - 1,
	                                    -mine->getCollRectX(),
	                                    mine->getCollRectY() + mine->getCollRectHeight() - 1,
	                                    -mine->getCollRectY() ),
	       avatar->getRandomizedAimingVector( 2, power ) + avatar->getSpeed(),
	       avatar->getPlayer()->getPlayerID(), deadTime, 150, 40 );
}
