/* $Id: weaponmissile.hpp,v 1.3 2004/06/28 08:50:40 pohlt Exp $ */

#ifndef _WEAPONMISSILE_HPP_
#define _WEAPONMISSILE_HPP_

#include "weapon.hpp"
#include "missile.hpp"
#include "audio.hpp"

class WeaponMissile : public Weapon {
	public:
		WeaponMissile() {
			rechargeNow();
			m_shotSample = Audio::getInstance()->loadSound( "sound/weapons/missile/launch.wav" );
			Missile::m_explodeSample = Audio::getInstance()->loadSound( "sound/effects/explosion1.wav" );
			Missile::m_damageSample = Audio::getInstance()->loadSound( "sound/effects/ricochet.wav" );
		}

		virtual bool reallyShoot( World* world, Avatar* avatar ) const ;
		
		virtual Uint32 getMaximumAmmo() const {
			return 4;
		}
		virtual Uint32 getReloadTime() const {
			return 15;
		}
		virtual Uint32 getChargeTime() const {
			return 100;
		}
};

#endif // _WEAPONMISSILE_HPP_
