/* $Id: weaponshotgun.cpp,v 1.16 2005/04/08 13:16:04 pohlt Exp $ */

#include "weaponshotgun.hpp"
#include "world.hpp"
#include "avatar.hpp"

bool WeaponShotgun::reallyShoot( World* world, Avatar* avatar ) const {
	const int N_BULLETS = 50;
	real power;

	// place bullet particles
	Vector startPos = avatar->placeBesideCollRect();

	for( int s = 0; s < N_BULLETS; s++ ) {
		power = 30.0 - 6.0 * globalRnd.getNormedReal();
		world->getParticles()->addParticle( Particles::ParticleData(
				startPos,
				avatar->getRandomizedAimingVector( 20, power ) + avatar->getSpeed(),
		    Particles::EXPL_EARTH | Particles::EXPL_OBJECT | Particles::DAMAGE | Particles::EXPL_GEN_SPARKS,
		    0, avatar->getPlayer()->getPlayerID(), 100, 10, 0xffffff));
	}

	// apply recoil
	avatar->setSpeed( avatar->getSpeedX() - N_BULLETS * avatar->getAimingDX() * power / avatar->getMass(),
	                  avatar->getSpeedY() - N_BULLETS * avatar->getAimingDY() * power / avatar->getMass() );

	return true;
}
